
if (GetLocale() == "enUS" or GetLocale() == "enGB") then
	-- equip and set bonus prefixes:
	HEALPOINTSBS_PREFIX_EQUIP = "Equip: ";
	HEALPOINTSBS_PREFIX_SET = "Set: ";
	
	-- passive bonus patterns. checked against lines which start with above prefixes
	HEALPOINTSBS_PATTERNS_PASSIVE = {
		{ pattern = "Improves your chance to get a critical strike with spells by (%d+)%%%.", effect = "SPELLCRIT" },
		{ pattern = "Improves your chance to get a critical strike with Holy spells by (%d+)%%%.", effect = "HOLYCRIT" },
		{ pattern = "Increases the critical effect chance of your Holy spells by (%d+)%%%.", effect = "HOLYCRIT" },
		{ pattern = "Increases healing done by spells and effects by up to (%d+)%.", effect = "HEAL" },
		{ pattern = "Increases damage and healing done by magical spells and effects by up to (%d+)%.", effect = "HEAL" },
		{ pattern = "Restores (%d+) mana per 5 sec%.", effect = "MANAREG" },
		{ pattern = "Restores (%d+) mana every 5 sec%.", effect = "MANAREG" },
	
		-- Added
		{ pattern = "Allows (%d+)%% of your Mana regeneration to continue while casting%.", effect = "CASTINGREG"},		
		{ pattern = "Improves your chance to get a critical strike with Nature spells by (%d+)%%%.", effect = "NATURECRIT"}, 
		{ pattern = "Reduces the casting time of your Regrowth spell by 0%.(%d+) sec%.", effect = "CASTINGREGROWTH"}, 
		{ pattern = "Reduces the casting time of your Holy Light spell by 0%.(%d+) sec%.", effect = "CASTINGHOLYLIGHT"}, 
		{ pattern = "%-0%.(%d+) sec to the casting time of your Flash Heal spell%.", effect = "CASTINGFLASHHEAL"}, 
		{ pattern = "Increases the duration of your Rejuvenation spell by (%d+) sec%.", effect = "DURATIONREJUV"},
		{ pattern = "Increases your normal health and mana regeneration by (%d+)%.", effect = "MANAREGNORMAL"}
	};
	
	-- generic patterns have the form "+xx bonus" or "bonus +xx" with an optional % sign after the value.
	
	-- first the generic bonus string is looked up in the following table
	HEALPOINTSBS_PATTERNS_GENERIC_LOOKUP = {
		["All Stats"] 			= {"INT", "SPI"},
		["Intellect"]			= "INT",
		["Spirit"] 				= "SPI",
	
		["Healing Spells"] 		= "HEAL",
		["Increases Healing"] 	= "HEAL",
		["Healing and Spell Damage"] = "HEAL",
		["Damage and Healing Spells"] = "HEAL",
		["Spell Damage and Healing"] = "HEAL",	
		["mana every 5 sec"] 	= "MANAREG",
		["Mana Regen"] 			= "MANAREG",
		["Mana"]				= "MANA",
	};	
	
	-- next we try to match against one pattern of stage 1 and one pattern of stage 2 and concatenate the effect strings
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE1 = {
	}; 	
	
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE2 = {
	}; 	
	
	-- finally if we got no match, we match against some special enchantment patterns.
	HEALPOINTSBS_PATTERNS_OTHER = {
		{ pattern = "Mana Regen (%d+) per 5 sec%.", effect = "MANAREG" },
		{ pattern = "Zandalar Signet of Mojo", effect = "HEAL", value = 18 },
		{ pattern = "Zandalar Signet of Serenity", effect = "HEAL", value = 33 },
		
		{ pattern = "Minor Wizard Oil", effect = "HEAL", value = 8 },
		{ pattern = "Lesser Wizard Oil", effect = "HEAL", value = 16 },
		{ pattern = "Wizard Oil", effect = "HEAL", value = 24 },
		{ pattern = "Brilliant Wizard Oil", effect = {"HEAL", "SPELLCRIT"}, value = {36, 1} },
	
		{ pattern = "Minor Mana Oil", effect = "MANAREG", value = 4 },
		{ pattern = "Lesser Mana Oil", effect = "MANAREG", value = 8 },
		{ pattern = "Brilliant Mana Oil", effect = { "MANAREG", "HEAL"}, value = {12, 25} },	
	};

elseif (GetLocale() == "deDE") then
	-- Prfixe fr passive und Set-Boni
	HEALPOINTSBS_PREFIX_EQUIP = "Anlegen: ";
	HEALPOINTSBS_PREFIX_SET = "Set: ";
	
	-- Suchmuster fr passive Boni. Wird auf Zeilen angewandt, die mit obigen Prfixen beginnen.
	HEALPOINTSBS_PATTERNS_PASSIVE = {
		{ pattern = "Erhöht Eure Chance, einen kritischen Schlag durch Zauber zu erzielen, um (%d+)%%%.", effect = "SPELLCRIT" },
		{ pattern = "Erhöht Eure Chance, einen kritischen Schlag durch Heiligzauber zu erzielen, um (%d+)%%%.", effect = "HOLYCRIT" },
		{ pattern = "Erhöht durch Zauber und magische Effekte zugefügten Schaden und Heilung um bis zu (%d+)%.", effect = "HEAL" },
		{ pattern = "Erhöht durch Zauber und Effekte verursachte Heilung um bis zu (%d+)%.", effect = "HEAL" },
		{ pattern = "Erhöht die durch Zauber und Effekte verursachte Heilung um bis zu (%d+)%.", effect = "HEAL" },
		{ pattern = "Stellt alle 5 Sek%. (%d+) Punkt%(e%) Mana wieder her%.", effect = "MANAREG" },

		{ pattern = "Ermglicht, dass (%d+)%% Eurer Mana-Regeneration whrend des Zauberwirkens weiterluft%.", effect = "CASTINGREG"},		
		{ pattern = "Erhht Eure Chance, einen kritischen Schlag durch Naturzauber zu erzielen, um (%d+)%%%.", effect = "NATURECRIT"}, 
		{ pattern = "Verringert die Zauberzeit Eures %'Nachwachsen%'%-Zaubers um 0%.(%d+) Sekunden%.", effect = "CASTINGREGROWTH"}, 
		{ pattern = "Verringert die Zauberzeit Eures %'Heiliges Licht%'%-Zaubers um 0%.(%d+) Sekunden%.", effect = "CASTINGHOLYLIGHT"}, 
		{ pattern = "%-0%.(%d+) Sek%. Zauberzeit fr Euren %'Blitzheilungs%'-Zauber%.", effect = "CASTINGFLASHHEAL"}, 
		{ pattern = "Verlngert die Dauer eures %'Verjngung%'%-Zaubers um (%d+) Sekunden.", effect = "DURATIONREJUV"},
		{ pattern = "Erhht Gesundheit%- und Mana%-Regeneration um (%d+)%.", effect = "MANAREGNORMAL"}
	};
		
		
	-- Suchmuster fr allgemeine Gegenstandsboni in der Form "+xx bonus" oder "bonus +xx" (%-Zeichen nach dem Wert ist optional)
	
	-- Zuerst wird versucht den "bonus"-String in der folgenden Tabelle nachzuschlagen
	HEALPOINTSBS_PATTERNS_GENERIC_LOOKUP = {
		["Alle Werte"] 			= {"INT", "SPI"},
		["Intelligenz"]			= "INT",
		["Willenskraft"] 		= "SPI",
	
		["Mana alle 5 Sek"] 	= "MANAREG",
		["Manaregeneration"]	= "MANAREG",
		["Heilzauber"]			= "HEAL",
		["Heilung und Zauberschaden"] = "HEAL",
		["Mana"]				= "MANA",
	};
	
	-- ... dann wird versucht ob eines der Stage 1 und eines der Stage 2 Muster passt und daraus ein Effect-String zusammengesetzt
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE1 = {
	}; 	
	
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE2 = {
	}; 	
	
	-- Zuletzt, falls immer noch kein Treffer vorliegt wird noch auf einige spezielle Verzauberungen berprft.
	HEALPOINTSBS_PATTERNS_OTHER = {
		{ pattern = "Manaregeneration (%d+) per 5 Sek%.", effect = "MANAREG" },
		{ pattern = "Zandalarianisches Siegel des Mojo", effect = "HEAL", value = 18 },
		{ pattern = "Zandalarianisches Siegel der Inneren Ruhe", effect = "HEAL", value = 33 },
		
		{ pattern = "Schwaches Zauberöl", effect = "HEAL", value = 8 },
		{ pattern = "Geringes Zauberöl", effect = "HEAL", value = 16 },
		{ pattern = "Zauberöl", effect = "HEAL", value = 24 },
		{ pattern = "Hervorragendes Zauberöl", effect = {"HEAL", "SPELLCRIT"}, value = {36, 1} },
	
		{ pattern = "Schwaches Manaöl", effect = "MANAREG", value = 4 },
		{ pattern = "Geringes Manaöl", effect = "MANAREG", value = 8 },
		{ pattern = "Hervorragendes Manaöl", effect = { "MANAREG", "HEAL"}, value = {12, 25} }
	
	};
elseif (GetLocale() == "frFR") then
end