
-- Global variables
local SPELLTABLE_FAST = nil;
local SPELLTABLE_SLOW = nil;
local SPELLTABLE_HOT = nil;
local SELECTED_FAST = nil;
local SELECTED_SLOW = nil;
local SELECTED_HOT = nil;
local HealPointsCalculator_ManaRegainedOnCrit = 0;
local HealPointsCalculator_ExtraRegrowthCrit = 0;
local HealPointsCalculator_ExtraMana = 0;	
local HealPointsCalculator_ExtraInt = 0; 
local HealPointsCalculator_ExtraSpi = 0;
local HP_LastPowerfulCurrent = nil;
local HP_LastPowerfulNew = nil;
local HP_LastEfficientCurrent = nil;
local HP_LastEfficientNew = nil;

-- Spell tables
local Paladin_Fast = {	{ name = "Flash of Light", rank = 1, abbr = "FoL", avg = 67, time = 1.5, mana = 35, healfactor = 1, bolfactor = 1}, 
						{ name = "Flash of Light", rank = 2, abbr = "FoL", avg = 103, time = 1.5, mana = 50, healfactor = 1, bolfactor = 1},
						{ name = "Flash of Light", rank = 3, abbr = "FoL", avg = 154, time = 1.5, mana = 70, healfactor = 1, bolfactor = 1},
						{ name = "Flash of Light", rank = 4, abbr = "FoL", avg = 209, time = 1.5, mana = 90, healfactor = 1, bolfactor = 1},
						{ name = "Flash of Light", rank = 5, abbr = "FoL", avg = 283, time = 1.5, mana = 115, healfactor = 1, bolfactor = 1},
						{ name = "Flash of Light", rank = 6, abbr = "FoL", avg = 363, time = 1.5, mana = 140, healfactor = 1, bolfactor = 1}};
local Paladin_Slow = {	{ name = "Holy Light", rank = 1, abbr = "HL", avg = 43, time = 2.5, mana = 35, healfactor = 0.286, bolfactor = 0.2},	
						{ name = "Holy Light", rank = 2, abbr = "HL", avg = 83, time = 2.5, mana = 60, healfactor = 0.475, bolfactor = 0.4},
						{ name = "Holy Light", rank = 3, abbr = "HL", avg = 173, time = 2.5, mana = 110, healfactor = 0.769, bolfactor = 0.7},
						{ name = "Holy Light", rank = 4, abbr = "HL", avg = 333, time = 2.5, mana = 190, healfactor = 1, bolfactor = 1},				
						{ name = "Holy Light", rank = 5, abbr = "HL", avg = 522, time = 2.5, mana = 275, healfactor = 1, bolfactor = 1},				
						{ name = "Holy Light", rank = 6, abbr = "HL", avg = 739, time = 2.5, mana = 365, healfactor = 1, bolfactor = 1},				
						{ name = "Holy Light", rank = 7, abbr = "HL", avg = 999, time = 2.5, mana = 465, healfactor = 1, bolfactor = 1},				
						{ name = "Holy Light", rank = 8, abbr = "HL", avg = 1317, time = 2.5, mana = 580, healfactor = 1, bolfactor = 1},
						{ name = "Holy Light", rank = 9, abbr = "HL", avg = 1680, time = 2.5, mana = 660, healfactor = 1, bolfactor = 1}};
local Paladin_BoL =  {	{ rank = 1, holyLight = 210, flashOfLight = 60},
						{ rank = 2, holyLight = 300, flashOfLight = 85},
						{ rank = 3, holyLight = 400, flashOfLight = 115}};

local Priest_Fast = {	{ name = "Flash Heal", rank = 1, abbr = "FH", avg = 215, time = 1.5, mana = 125, healfactor = 1}, 
						{ name = "Flash Heal", rank = 2, abbr = "FH", avg = 286, time = 1.5, mana = 155, healfactor = 1},
						{ name = "Flash Heal", rank = 3, abbr = "FH", avg = 360, time = 1.5, mana = 185, healfactor = 1},
						{ name = "Flash Heal", rank = 4, abbr = "FH", avg = 439, time = 1.5, mana = 215, healfactor = 1},
						{ name = "Flash Heal", rank = 5, abbr = "FH", avg = 567, time = 1.5, mana = 265, healfactor = 1},
						{ name = "Flash Heal", rank = 6, abbr = "FH", avg = 704, time = 1.5, mana = 315, healfactor = 1},
						{ name = "Flash Heal", rank = 7, abbr = "FH", avg = 885, time = 1.5, mana = 380, healfactor = 1}};
local Priest_Slow = {	{ name = "Lesser Heal", rank = 1, abbr = "LH", avg = 51, time = 1.5, mana = 35, healfactor = 0.294}, 
						{ name = "Lesser Heal", rank = 2, abbr = "LH", avg = 78, time = 2.0, mana = 50, healfactor = 0.391},
						{ name = "Lesser Heal", rank = 3, abbr = "LH", avg = 146, time = 2.5, mana = 85, healfactor = 0.633},
						{ name = "Heal", rank = 1, abbr = "Heal", avg = 318, time = 3.0, mana = 170, healfactor = 0.859},
						{ name = "Heal", rank = 2, abbr = "Heal", avg = 535, time = 3.5, mana = 265, healfactor = 1},
						{ name = "Heal", rank = 3, abbr = "Heal", avg = 805, time = 4.0, mana = 375, healfactor = 1},
						{ name = "Heal", rank = 4, abbr = "Heal", avg = 1010, time = 4.0, mana = 450, healfactor = 1},
						{ name = "Greater Heal", rank = 1, abbr = "GH", avg = 1277, time = 4.0, mana = 545, healfactor = 1},
						{ name = "Greater Heal", rank = 2, abbr = "GH", avg = 1624, time = 4.0, mana = 665, healfactor = 1},
						{ name = "Greater Heal", rank = 3, abbr = "GH", avg = 2033, time = 4.0, mana = 800, healfactor = 1},
						{ name = "Greater Heal", rank = 4, abbr = "GH", avg = 2535, time = 4.0, mana = 960, healfactor = 1},
						{ name = "Greater Heal", rank = 5, abbr = "GH", avg = 2770, time = 4.0, mana = 1040, healfactor = 1}};
local Priest_Hot = {	{ name = "Renew", rank = 1, abbr = "Renew", avg = 45, time = 15, mana = 30, healfactor = 0.541}, 
						{ name = "Renew", rank = 2, abbr = "Renew", avg = 100, time = 15, mana = 65, healfactor = 0.755},
						{ name = "Renew", rank = 3, abbr = "Renew", avg = 175, time = 15, mana = 105, healfactor = 1},
						{ name = "Renew", rank = 4, abbr = "Renew", avg = 245, time = 15, mana = 140, healfactor = 1},
						{ name = "Renew", rank = 5, abbr = "Renew", avg = 315, time = 15, mana = 170, healfactor = 1},
						{ name = "Renew", rank = 6, abbr = "Renew", avg = 400, time = 15, mana = 205, healfactor = 1},
						{ name = "Renew", rank = 7, abbr = "Renew", avg = 510, time = 15, mana = 250, healfactor = 1},
						{ name = "Renew", rank = 8, abbr = "Renew", avg = 650, time = 15, mana = 305, healfactor = 1},
						{ name = "Renew", rank = 9, abbr = "Renew", avg = 810, time = 15, mana = 365, healfactor = 1},
						{ name = "Renew", rank = 10, abbr = "Renew", avg = 970, time = 15, mana = 410, healfactor = 1}};
				
local Druid_Fast = {	{ name = "Regrowth", rank = 1, abbr = "Regr", avg = 91, time = 2, mana = 120, hotavg = 98, hottime = 21, healfactor = 0.704}, 
						{ name = "Regrowth", rank = 2, abbr = "Regr", avg = 176, time = 2, mana = 205, hotavg = 175, hottime = 21, healfactor = 0.928},
						{ name = "Regrowth", rank = 3, abbr = "Regr", avg = 257, time = 2, mana = 280, hotavg = 259, hottime = 21, healfactor = 1},
						{ name = "Regrowth", rank = 4, abbr = "Regr", avg = 339, time = 2, mana = 350, hotavg = 343, hottime = 21, healfactor = 1},
						{ name = "Regrowth", rank = 5, abbr = "Regr", avg = 431, time = 2, mana = 420, hotavg = 427, hottime = 21, healfactor = 1},
						{ name = "Regrowth", rank = 6, abbr = "Regr", avg = 543, time = 2, mana = 510, hotavg = 546, hottime = 21, healfactor = 1},
						{ name = "Regrowth", rank = 7, abbr = "Regr", avg = 685, time = 2, mana = 615, hotavg = 686, hottime = 21, healfactor = 1},
						{ name = "Regrowth", rank = 8, abbr = "Regr", avg = 857, time = 2, mana = 740, hotavg = 861, hottime = 21, healfactor = 1},
						{ name = "Regrowth", rank = 9, abbr = "Regr", avg = 1061, time = 2, mana = 880, hotavg = 1064, hottime = 21, healfactor = 1}};
local Druid_Slow = { 	{ name = "Healing Touch", rank = 1, abbr = "HT", avg = 44, time = 1.5, mana = 30, healfactor = 0.280}, 
						{ name = "Healing Touch", rank = 2, abbr = "HT", avg = 100, time = 2.0, mana = 60, healfactor = 0.567}, 
						{ name = "Healing Touch", rank = 3, abbr = "HT", avg = 219, time = 2.5, mana = 120, healfactor = 0.773}, 
						{ name = "Healing Touch", rank = 4, abbr = "HT", avg = 404, time = 3.0, mana = 205, healfactor = 1},
						{ name = "Healing Touch", rank = 5, abbr = "HT", avg = 633, time = 3.5, mana = 300, healfactor = 1},
						{ name = "Healing Touch", rank = 6, abbr = "HT", avg = 818, time = 3.5, mana = 370, healfactor = 1},
						{ name = "Healing Touch", rank = 7, abbr = "HT", avg = 1028, time = 3.5, mana = 445, healfactor = 1},
						{ name = "Healing Touch", rank = 8, abbr = "HT", avg = 1313, time = 3.5, mana = 545, healfactor = 1},
						{ name = "Healing Touch", rank = 9, abbr = "HT", avg = 1656, time = 3.5, mana = 660, healfactor = 1},
						{ name = "Healing Touch", rank = 10, abbr = "HT", avg = 2060, time = 3.5, mana = 790, healfactor = 1},
						{ name = "Healing Touch", rank = 11, abbr = "HT", avg = 2472, time = 3.5, mana = 880, healfactor = 1}};
local Druid_Hot = {		{ name = "Rejuvenation", rank = 1, abbr = "Rejuv", avg = 32, time = 12, mana = 25, healfactor = 0.400}, 
						{ name = "Rejuvenation", rank = 2, abbr = "Rejuv", avg = 56, time = 12, mana = 40, healfactor = 0.625},
						{ name = "Rejuvenation", rank = 3, abbr = "Rejuv", avg = 116, time = 12, mana = 75, healfactor = 0.845},
						{ name = "Rejuvenation", rank = 4, abbr = "Rejuv", avg = 180, time = 12, mana = 105, healfactor = 1},
						{ name = "Rejuvenation", rank = 5, abbr = "Rejuv", avg = 244, time = 12, mana = 135, healfactor = 1},
						{ name = "Rejuvenation", rank = 6, abbr = "Rejuv", avg = 304, time = 12, mana = 160, healfactor = 1},
						{ name = "Rejuvenation", rank = 7, abbr = "Rejuv", avg = 388, time = 12, mana = 195, healfactor = 1},
						{ name = "Rejuvenation", rank = 8, abbr = "Rejuv", avg = 488, time = 12, mana = 235, healfactor = 1},
						{ name = "Rejuvenation", rank = 9, abbr = "Rejuv", avg = 608, time = 12, mana = 280, healfactor = 1},
						{ name = "Rejuvenation", rank = 10, abbr = "Rejuv", avg = 756, time = 12, mana = 335, healfactor = 1},
						{ name = "Rejuvenation", rank = 11, abbr = "Rejuv", avg = 888, time = 12, mana = 360, healfactor = 1}};				

local Shaman_Fast = {	{ name = "Lesser Healing Wave", rank = 1, abbr = "LHW", avg = 174, time = 1.5, mana = 105, healfactor = 1}, 
						{ name = "Lesser Healing Wave", rank = 2, abbr = "LHW", avg = 264, time = 1.5, mana = 145, healfactor = 1},
						{ name = "Lesser Healing Wave", rank = 3, abbr = "LHW", avg = 359, time = 1.5, mana = 185, healfactor = 1},
						{ name = "Lesser Healing Wave", rank = 4, abbr = "LHW", avg = 486, time = 1.5, mana = 235, healfactor = 1},
						{ name = "Lesser Healing Wave", rank = 5, abbr = "LHW", avg = 668, time = 1.5, mana = 305, healfactor = 1},
						{ name = "Lesser Healing Wave", rank = 6, abbr = "LHW", avg = 880, time = 1.5, mana = 380, healfactor = 1}};
local Shaman_Slow = {	{ name = "Healing Wave", rank = 1, abbr = "HW", avg = 39, time = 1.5, mana = 30, healfactor = 0.290}, 
						{ name = "Healing Wave", rank = 2, abbr = "HW", avg = 71, time = 2.0, mana = 50, healfactor = 0.477},
						{ name = "Healing Wave", rank = 3, abbr = "HW", avg = 142, time = 2.5, mana = 90, healfactor = 0.701},
						{ name = "Healing Wave", rank = 4, abbr = "HW", avg = 292, time = 3.0, mana = 170, healfactor = 0.925},
						{ name = "Healing Wave", rank = 5, abbr = "HW", avg = 408, time = 3.0, mana = 220, healfactor = 1},
						{ name = "Healing Wave", rank = 6, abbr = "HW", avg = 579, time = 3.0, mana = 290, healfactor = 1},
						{ name = "Healing Wave", rank = 7, abbr = "HW", avg = 797, time = 3.0, mana = 375, healfactor = 1},
						{ name = "Healing Wave", rank = 8, abbr = "HW", avg = 1092, time = 3.0, mana = 485, healfactor = 1},
						{ name = "Healing Wave", rank = 9, abbr = "HW", avg = 1464, time = 3.0, mana = 615, healfactor = 1},
						{ name = "Healing Wave", rank = 10, abbr = "HW", avg = 1735, time = 3.0, mana = 680, healfactor = 1}};

-- Helper functions
local function getHighestSpellRank(spellName)
	local totalSpellTabs = GetNumSpellTabs();
	local totalSpells = 0;
	for t = 1, totalSpellTabs do
		local _, _, _, numSpells = GetSpellTabInfo(t);
		totalSpells = totalSpells + numSpells;
	end

	local highestRank = 0;
	for t = 1, totalSpells do
		local nameSpell, rankSpell = GetSpellName(t, BOOKTYPE_SPELL);
		if (nameSpell == spellName) then		
			local j, k = string.find(rankSpell, "Rank ");
			if (j ~= nil) then
				highestRank = math.max(highestRank, string.sub(rankSpell, k));
			end
		end
	end
	return highestRank;
end

local function getHighestKnownSpell(spellTable)
	if (spellTable == nil) then
		return nil;
	end
	for i = table.getn(spellTable), 1, -1 do
		if (getHighestSpellRank(spellTable[i]['name']) == spellTable[i]['rank']) then
			return spellTable[i];
		end
	end
	return nil;
end

local function getTalentRank(talentName)
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			local nameTalent, _, _, _, currRank, _ = GetTalentInfo(t,i);
			if (nameTalent == talentName) then
				return currRank
			end
		end
	end
	return 0;
end

local function getHPCast(spell, spellType, healing, spellCrit)
	if (spell['name'] == "Regrowth") then
		-- Static part
		local out = spell['avg'];
		out = out + ((spell['healfactor'] * healing / 2) / (3.5 / (math.min(spell['orgtime'], 3.5))));
		out = out + ((spellCrit + HealPointsCalculator_ExtraRegrowthCrit) / 200) * out;		-- Crit adds 50% for non-hot
		-- HOT part
		out = out + spell['hotavg'];
		out = out + ((spell['healfactor'] * healing / 2) / (15 / (math.min(spell['hottime'], 15))));
		return out;
	else
		local maxTime = 3.5;
		if (spellType == 'hot') then
			maxTime = 15;
		end
		local out = spell['avg'];
		if (getglobal("HealPointsCalculatorBoL"):GetChecked() == 1) then
			local bolRank = getHighestSpellRank("Blessing of Light");
			if (bolRank > 0) then
				local bol = Paladin_BoL[bolRank];
				if (spellType == 'fast') then
					out = out + spell['bolfactor'] * bol['flashOfLight'];
				elseif (spellType == 'slow') then
					out = out + spell['bolfactor'] * bol['holyLight'];
				end
			end
		end
		out = out + (spell['healfactor'] * healing / (maxTime / (math.min(spell['orgtime'], maxTime))));
		if (spellType ~= 'hot') then
			out = out + (spellCrit / 200) * out;		-- Crit adds 50% for non-hot
		end
		return out;
	end
end

local function getHPSec(spell, spellType, healing, spellCrit)
	local out = getHPCast(spell, spellType, healing, spellCrit);

	if (spell['name'] == "Regrowth") then
		return out/(spell['hottime'] + spell['time']);	
	else
		return out/spell['time'];
	end
end

local function getHPMana(spell, spellType, healing, spellCrit)
	local out = getHPCast(spell, spellType, healing, spellCrit);

	return out / (spell['mana'] * (1 - (spellCrit / 100) * HealPointsCalculator_ManaRegainedOnCrit));
end

local function getHPTotal(hpMana,mana)
	return hpMana * mana;
end

local function getHPTotalRegen(spell, spellType, healing, spellCrit, manaRegenCasting, mana)
	local out = getHPCast(spell, spellType, healing, spellCrit);

	local manaUsageSpell = spell['mana'] * (1 - (spellCrit / 100) * HealPointsCalculator_ManaRegainedOnCrit);
	local manaRegen = spell['time'] * (manaRegenCasting / 5);
	if (spell['name'] == "Regrowth") then
		manaRegen = (spell['time'] + spell['hottime']) * (manaRegenCasting / 5);
	end
	local manaUsage = manaUsageSpell - manaRegen;
	
	local hpmanaRegen = out / manaUsage;
	return hpmanaRegen * mana;
end

local function updateSpellTalents(slow, fast, hot)	
	local function clone(t)            -- return a copy of the table t
		if (t == nil) then
			return nil
		end
		local new = {}             -- create a new table
		local i, v = next(t, nil)  -- i is an index of t, v = t[i]
		while i do
			new[i] = v
			i, v = next(t, i)        -- get next index
		end
		new['orgtime'] = t['time'] -- copy the time-stat
		return new
	end

	local function updateSpellPercent(spell, aspect, percentIncrease)
		if (spell ~= nil) then
			spell[aspect] = spell[aspect] * (1 + percentIncrease);
		end
	end
	
	local function updateSpellAbsolute(spell, aspect, increase)
		if (spell ~= nil) then
			spell[aspect] = spell[aspect] + increase;
		end
	end

	slow = clone(slow);
	fast = clone(fast);
	hot = clone(hot);
	HealPointsCalculator_ManaRegainedOnCrit = 0;
	HealPointsCalculator_ExtraRegrowthCrit = 0;
	HealPointsCalculator_ExtraMana = 0;
	HealPointsCalculator_ExtraInt = 0;
	local _, className = UnitClass("player");
	
	if (className == "PALADIN") then
		-- talents for paladins
		local divineIntellect = getTalentRank("Divine Intellect");	-- Increases intellect by 2% per rank
		HealPointsCalculator_ExtraInt = 0.02 * divineIntellect;
		
		local healingLight = getTalentRank("Healing Light");		-- Increases avg for both spells by 4% per rank
		updateSpellPercent(slow, 'avg', healingLight * 0.04);
		updateSpellPercent(fast, 'avg', healingLight * 0.04);
		
		local illumination = getTalentRank("Illumination");			-- 20% chance to regain mana on crit per rank
		HealPointsCalculator_ManaRegainedOnCrit = 0.20 * illumination;
		
		-- special set bonuses
		if (HealPointsBS:GetBonus('CASTINGHOLYLIGHT') > 0) then
			updateSpellAbsolute(slow, 'time', - HealPointsBS:GetBonus('CASTINGHOLYLIGHT') / 10);
		end

	elseif (className == "PRIEST") then
		-- talents for priests
		local mentalAgility = getTalentRank("Mental Agility");		-- Reduced mana cost for Renew by 2% per rank
		updateSpellPercent(hot, 'mana', - mentalAgility * 0.02);
		
		local improvedRenew = getTalentRank("Improved Renew");		-- Increased avg for Renew by 3% per rank
		updateSpellPercent(hot, 'avg', improvedRenew * 0.03);
		
		local spiritualHealing = getTalentRank("Spiritual Healing");-- Increased avg for all spells by 2% per rank
		updateSpellPercent(fast, 'avg', spiritualHealing * 0.02);
		updateSpellPercent(slow, 'avg', spiritualHealing * 0.02);
		updateSpellPercent(hot, 'avg', spiritualHealing * 0.02);
		
		local improvedHealing = getTalentRank("Improved Healing");  -- Reduced mana cost for slow heal by 3% per rank
		updateSpellPercent(slow, 'mana', - improvedHealing * 0.03);
		
		if (slow ~= nil and slow['name'] ~= "Lesser Heal") then
			local masterHealer = getTalentRank("Master Healer");	-- Reduced time for Heal/Greater Heal by 0.1 per rank
			updateSpellAbsolute(slow, 'time', - masterHealer * 0.1);
		end
		
		local mentalStrength = getTalentRank("Mental Strength");	-- Increases maximum mana by 2% per rank
		HealPointsCalculator_ExtraMana = 0.02 * mentalStrength;

		-- special set bonuses
		if (HealPointsBS:GetBonus('CASTINGFLASHHEAL') > 0) then
			updateSpellAbsolute(fast, 'time', - HealPointsBS:GetBonus('CASTINGFLASHHEAL') / 10);
		end

	elseif (className == "DRUID") then
		-- talents for druids
		local moonglow = getTalentRank("Moonglow");					-- Reduced mana cost for all spells by 3% per rank
		updateSpellPercent(fast, 'mana', - moonglow * 0.03);
		updateSpellPercent(slow, 'mana', - moonglow * 0.03);
		updateSpellPercent(hot, 'mana', - moonglow * 0.03);
		
		local improvedHT = getTalentRank("Improved Healing Touch")	-- Reduced time for Healing Touch by 0.1 per rank
		updateSpellAbsolute(slow, 'time', - improvedHT * 0.1);
		
		local tranquilSpirit = getTalentRank("Tranquil Spirit")		-- Reduced mana cost for Healing Touch by 2% per rank
		updateSpellPercent(slow, 'mana', - tranquilSpirit * 0.02);
		
		local improvedRejuv = getTalentRank("Improved Rejuvenation")-- Increased avg for Rejuvenation by 5% per rank
		updateSpellPercent(hot, 'avg', improvedRejuv * 0.05);
		
		local giftOfNature = getTalentRank("Gift of Nature")		-- Increased avg for all spells by 2% per rank
		updateSpellPercent(fast, 'avg', giftOfNature * 0.02);
		updateSpellPercent(fast, 'hotavg', giftOfNature * 0.02);
		updateSpellPercent(slow, 'avg', giftOfNature * 0.02);
		updateSpellPercent(hot, 'avg', giftOfNature * 0.02);

		local improvedRegrowth = getTalentRank("Gift of Nature");	-- Increases crit for Regrowth by 10% per rank
		HealPointsCalculator_ExtraRegrowthCrit = 10 * improvedRegrowth;
		
		local heartOfTheWild = getTalentRank("Heart of the Wild");	-- Increases int by 4% per rank
		HealPointsCalculator_ExtraInt = 0.04 * heartOfTheWild;

		-- special set bonuses
		if (HealPointsBS:GetBonus('CASTINGREGROWTH') > 0) then
			updateSpellAbsolute(fast, 'time', - HealPointsBS:GetBonus('CASTINGREGROWTH') / 10);
		end

		if (HealPointsBS:GetBonus('DURATIONREJUV') > 0) then
			updateSpellAbsolute(hot, 'time', HealPointsBS:GetBonus('DURATIONREJUV'));
			updateSpellPercent(hot, 'avg', HealPointsBS:GetBonus('DURATIONREJUV') / 12); -- From 4 tics to 5 tics => 25 % increase
		end

	elseif (className == "SHAMAN") then
		-- talents for shaman
		local improvedHealingWave = getTalentRank("Improved Healing Wave")	-- Reduced time for Healing Wave by 0.1 per rank
		updateSpellAbsolute(slow, 'time', - improvedHealingWave * 0.1);
		
		local tidalFocus = getTalentRank("Tidal Focus")						-- Reduced mana cost for all spells by 1% per rank
		updateSpellPercent(fast, 'mana', - tidalFocus * 0.01);
		updateSpellPercent(slow, 'mana', - tidalFocus * 0.01);
		
		local purification = getTalentRank("Purification")					-- Increased avg for all spells by 2% per rank
		updateSpellPercent(fast, 'avg', purification * 0.02);
		updateSpellPercent(slow, 'avg', purification * 0.02);

		local ancestralKnowledge = getTalentRank("Ancestral Knowledge");    -- Increases maximum mana by 1% per rank
		HealPointsCalculator_ExtraMana = 0.01 * ancestralKnowledge;
	end
	return slow, fast, hot;
end

local function computeTotalHealing(spell, hps, seconds, startMana, manaRegenCasting, manaRegenNormal, manaRegainFactor)
	--DEFAULT_CHAT_FRAME:AddMessage("Computing total healing for "..spell['name'].."("..spell['rank']..")  secs="..seconds.."  mana="..startMana,1,1,1);

	-- Phase 1: Has mana to chain-cast
	local manaUsageSpell = spell['mana'] * manaRegainFactor;
	local manaUsageSecond = (manaUsageSpell / spell['time']) - (manaRegenCasting / 5);
	local secondsPhase1 = math.min(seconds, startMana / manaUsageSecond);
	local totalHealed = secondsPhase1 * hps;			
	--DEFAULT_CHAT_FRAME:AddMessage("Seconds phase1 "..secondsPhase1,1,1,1);
	--DEFAULT_CHAT_FRAME:AddMessage("Healed phase1 "..totalHealed,1,1,1);

	-- Phase 2: Has no mana left
	local secondsPhase2 = seconds - secondsPhase1;
	if (secondsPhase2 > 0) then
		local cycleTime;                      -- Seconds between each casting
		if (manaRegenCasting > manaUsageSpell) then 	-- chaincast inside 5s rule
			local secs = manaUsageSpell / (manaRegenCasting / 5);
			cycleTime = math.max(secs, spell['time']);
		else
			local manaToRegen = manaUsageSpell - manaRegenCasting;
			cycleTime = 5 + manaToRegen / (manaRegenNormal / 5);
		end
    local hpsPhase2 = hps * spell['time'] / cycleTime;
    local healedPhase2 = hpsPhase2 * secondsPhase2;
	totalHealed = totalHealed + healedPhase2;
  	--DEFAULT_CHAT_FRAME:AddMessage("Cycletime phase2 "..cycleTime,1,1,1);
	--DEFAULT_CHAT_FRAME:AddMessage("Seconds phase2 "..secondsPhase2,1,1,1);
	--DEFAULT_CHAT_FRAME:AddMessage("Healed phase2 "..healedPhase2,1,1,1);		
	end
	return totalHealed;
end

local function computePowerPoints(healing, spellCrit, maxMana, manaRegenCasting, manaRegenNormal, manaRegainFactor)
	-- Healed in 30 sec by most powerful spell
	local powerfulSpell = getHighestKnownSpell(SPELLTABLE_SLOW);
	local alternative = getHighestKnownSpell(SPELLTABLE_FAST);	
	powerfulSpell, alternative, _ = updateSpellTalents(powerfulSpell, alternative);
	local hps = getHPSec(powerfulSpell, 'slow', healing, spellCrit);
	if (alternative ~= nil and alternative['name'] ~= "Regrowth") then
		local alternativehps = getHPSec(alternative, 'fast', healing, spellCrit);
		if (alternativehps > hps) then
			powerfulSpell = alternative;
			hps = alternativehps;
		end
	end
	local powerPoints = computeTotalHealing(powerfulSpell, hps, 30, maxMana, manaRegenCasting, manaRegenNormal, manaRegainFactor);
	return powerPoints, powerfulSpell;
end

local function computeEndurancePoints(healing, spellCrit, manaRegenCasting, manaRegenNormal, manaRegainFactor)
	-- Healed in 3 mins by most efficient spell, starting with 0 mana
	local maxNum = math.max(table.getn(SPELLTABLE_SLOW), table.getn(SPELLTABLE_FAST));
	local efficientSpell = nil;
	local maxEndurancePoints = 0;
	for i = 1, maxNum, 1 do
		local slowSpell = SPELLTABLE_SLOW[i];
		local fastSpell = SPELLTABLE_FAST[i];
		slowSpell, fastSpell, _ = updateSpellTalents(slowSpell, fastSpell);
		if (slowSpell ~= nil and getHighestSpellRank(slowSpell['name']) >= slowSpell['rank']) then
			local hps = getHPSec(slowSpell, 'slow', healing, spellCrit);
			local endurancePoints = computeTotalHealing(slowSpell, hps, 3 * 60, 0, manaRegenCasting, manaRegenNormal, manaRegainFactor);
			if (endurancePoints > maxEndurancePoints) then
				efficientSpell = slowSpell;
				maxEndurancePoints = endurancePoints;
			end
		end
		if (fastSpell ~= nil and fastSpell['name'] ~= "Regrowth" and getHighestSpellRank(fastSpell['name']) >= fastSpell['rank']) then
			local hps = getHPSec(fastSpell, 'fast', healing, spellCrit);
			local endurancePoints = computeTotalHealing(fastSpell, hps, 3 * 60, 0, manaRegenCasting, manaRegenNormal, manaRegainFactor);
			if (endurancePoints > maxEndurancePoints) then
				efficientSpell = fastSpell;
				maxEndurancePoints = endurancePoints;
			end
		end		
	end
	return maxEndurancePoints, efficientSpell;
end

-- Old and new values
local function getCurrentAndNewManaRegen()
	local function getRegenSpirit(spirit)																													-- Beregner regen from spirit
		local _, className = UnitClass("player");	
		local regen = 0;
		if (className == "PRIEST") then
			regen = 13 + spirit / 4;
		else
			regen = 15 + spirit / 5; -- paladin, druid, shaman
		end
		return regen * 2.5; -- convert from /2s til /5s
	end

	local talentMeditation = getTalentRank("Meditation");	-- 3% spi mana regen while casting per rank (priest)
	local talentReflection = getTalentRank("Reflection"); 	-- 5% spi mana regen while casting per rank (druid)
	local percentRegen = 0.03 * talentMeditation + 0.05 * talentReflection + HealPointsBS:GetBonus('CASTINGREG') / 100;

	local _, currentSpirit, _, _ = UnitStat("player", 5);
	local manaRegenSpirit = getRegenSpirit(currentSpirit);
	local extraNormalRegen = HealPointsBS:GetBonus('MANAREGNORMAL');
	local manaRegen5 = HealPointsBS:GetBonus('MANAREG');

	local manaRegenNormal = manaRegenSpirit + manaRegen5 + extraNormalRegen;
	local manaRegenCasting = manaRegen5 + percentRegen * (manaRegenSpirit + extraNormalRegen);

	local spiDelta = getglobal("HealPointsVariables2InputBox"):GetNumber() * (1 + HealPointsCalculator_ExtraSpi);
	local spiritNew = currentSpirit + spiDelta;
	local percentRegenNew = percentRegen + getglobal("HealPointsVariables6InputBox"):GetNumber() / 100;
	local manaRegen5New = manaRegen5 + getglobal("HealPointsVariables4InputBox"):GetNumber();
	local manaRegenSpiritNew = getRegenSpirit(spiritNew);

	local manaRegenNormalNew = manaRegenSpiritNew + manaRegen5New + extraNormalRegen + getglobal("HealPointsVariables5InputBox"):GetNumber();
	local manaRegenCastingNew = manaRegen5New + percentRegenNew * (manaRegenSpiritNew + extraNormalRegen + getglobal("HealPointsVariables5InputBox"):GetNumber());
	return manaRegenNormal, manaRegenCasting, manaRegenNormalNew, manaRegenCastingNew, percentRegen;
end

local function getCurrentAndNewMaxMana()
	local currentMana = UnitManaMax("player");

	local intDelta = getglobal("HealPointsVariables1InputBox"):GetNumber() * (1 + HealPointsCalculator_ExtraInt);
	local newMana = currentMana + (getglobal("HealPointsVariables3InputBox"):GetNumber() + 15 * intDelta) * (1 + HealPointsCalculator_ExtraMana);
	return currentMana, newMana;
end

local function getCurrentAndNewHealing()
	local currentHealing = HealPointsBS:GetBonus('HEAL');

	local newHealing = currentHealing + getglobal("HealPointsVariables7InputBox"):GetNumber();
	return currentHealing, newHealing;
end

local function getCurrentAndNewSpellCrit()
	local _, currentIntellect, _, _ = UnitStat("player", 4);
	local talentCrit = getTalentRank("Holy Specialization") + getTalentRank("Tidal Mastery") + getTalentRank("Holy Power");
	local currentSpellCrit = (currentIntellect/59.5) +
	  HealPointsBS:GetBonus('SPELLCRIT') +
	  HealPointsBS:GetBonus('HOLYCRIT') +
	  HealPointsBS:GetBonus('NATURECRIT') +
	  talentCrit;

	local intDelta = getglobal("HealPointsVariables1InputBox"):GetNumber();
	intDelta = intDelta + HealPointsCalculator_ExtraInt * intDelta;
	local newSpellCrit = currentSpellCrit + getglobal("HealPointsVariables8InputBox"):GetNumber() + intDelta / 59.5;
	return currentSpellCrit, newSpellCrit;
end

-- GUI functions
local function setStat(statString, stat, delta)
	if (delta == 0) then
		statString:SetText(stat);
	elseif (delta > 0) then
		statString:SetText(GREEN_FONT_COLOR_CODE..stat..FONT_COLOR_CODE_CLOSE);
	else 
		statString:SetText(RED_FONT_COLOR_CODE..stat..FONT_COLOR_CODE_CLOSE);
	end	
end

local function setStatInfo(number, name, currentStat, extraDelta, numberFormat)
	local frame = getglobal("HealPointsVariables"..number);
	local label = getglobal(frame:GetName().."Label");
	local originalStatText = getglobal(frame:GetName().."OriginalStat");
	local inputBox = getglobal(frame:GetName().."InputBox");
	local newStatText = getglobal(frame:GetName().."NewStat");
	
	local delta = inputBox:GetNumber() + extraDelta;
	local newStat = currentStat + delta;
	label:SetText(name);
	if (numberFormat) then
		currentStat = format(numberFormat, currentStat);
		newStat = format(numberFormat, newStat);
	end
	originalStatText:SetText(currentStat);
	setStat(newStatText, newStat, delta);
end

local function setSpellInfo(number, spellType, oldVal, newVal, formatString)
	if (newVal > oldVal) then
		newVal = GREEN_FONT_COLOR_CODE..format(formatString,newVal)..FONT_COLOR_CODE_CLOSE;
	elseif (newVal < oldVal) then
		newVal = RED_FONT_COLOR_CODE..format(formatString,newVal)..FONT_COLOR_CODE_CLOSE;
	else
		newVal = format(formatString,newVal);
	end
	local spellString = getglobal("HealPointsSpell"..number..spellType);
	spellString:SetText(format("%s("..formatString..")", newVal, oldVal));
end

local function setResultInfo(number, name, currentStat, newStat, numberFormat)
	local frame = getglobal("HealPointsResult"..number);
	local label = getglobal(frame:GetName().."Label");
	local current = getglobal(frame:GetName().."Current");
	local delta = getglobal(frame:GetName().."Difference");
	local new = getglobal(frame:GetName().."Result");

	local deltaStat = newStat - currentStat;
	local deltaText = deltaStat;
	label:SetText(name);
	if (numberFormat) then
		currentStat = format(numberFormat, currentStat);
		newStat = format(numberFormat, newStat);
		deltaText = format(numberFormat, deltaText);
	end
	current:SetText(currentStat);
	setStat(delta, deltaText, deltaStat);
	setStat(new, newStat, deltaStat);
end

-- Update functions
local function updateSpellLists() 	-- Update dropdown menus
	local function updateSpellList(objref, spellTable)
		if (spellTable) then
			local count = 0;
			for i = 1, table.getn(spellTable), 1 do
				if (getHighestSpellRank(spellTable[i]['name']) >= spellTable[i]['rank']) then
					info = {};
					info.text = spellTable[i]['abbr'].." ("..spellTable[i]['rank']..")";
					info.func = HealPointsCalculatorDropDown_OnClick;
					if (objref and type(objref) == "table") then
						info.owner = objref;
					end
					UIDropDownMenu_AddButton(info)
					count = count + 1;
				end
			end
			if (UIDropDownMenu_GetSelectedID(objref) == nil) then
				UIDropDownMenu_SetSelectedID(objref, count);
			end
		end
	end

	UIDropDownMenu_Initialize(HealPointsSpellShort,function() updateSpellList(HealPointsSpellShort, SPELLTABLE_FAST); end);
	UIDropDownMenu_Initialize(HealPointsSpellLong,function() updateSpellList(HealPointsSpellLong, SPELLTABLE_SLOW); end);
	UIDropDownMenu_Initialize(HealPointsSpellHOT,function() updateSpellList(HealPointsSpellHOT, SPELLTABLE_HOT); end);
end

local function updateSpellTable() 	-- Update tables with info about currently selected spellrank	
	if (UIDropDownMenu_GetSelectedID(HealPointsSpellLong) == nil) then -- should not happen
		updateSpellLists()
	end
	
	SELECTED_FAST, SELECTED_SLOW, SELECTED_HOT = nil, nil, nil;
	local selectedRankFast = UIDropDownMenu_GetSelectedID(HealPointsSpellShort);
	local selectedRankSlow = UIDropDownMenu_GetSelectedID(HealPointsSpellLong);
	local selectedRankHOT = UIDropDownMenu_GetSelectedID(HealPointsSpellHOT);	
	if (selectedRankFast) then
		SELECTED_FAST = SPELLTABLE_FAST[selectedRankFast];
	end
	if (selectedRankSlow) then
		SELECTED_SLOW = SPELLTABLE_SLOW[selectedRankSlow];
	end
	if (selectedRankHOT and SPELLTABLE_HOT ~= nil) then
		SELECTED_HOT = SPELLTABLE_HOT[selectedRankHOT];
	end
	
	SELECTED_SLOW, SELECTED_FAST, SELECTED_HOT = updateSpellTalents(SELECTED_SLOW, SELECTED_FAST, SELECTED_HOT);
end	
	
local function updateStats() 		-- Update stats (int, spi, regen, ...)																				
	-- Intellect
	local _, currentIntellect, _, _ = UnitStat("player", 4);
	local intDelta = getglobal("HealPointsVariables1InputBox"):GetNumber();
	local extraInt = HealPointsCalculator_ExtraInt * intDelta;
	setStatInfo(1, "Intellect:", currentIntellect, extraInt, "%5.0f");
	intDelta = intDelta + extraInt;
	
	-- Spirit
	local _, currentSpirit, _, _ = UnitStat("player", 5);
	local extraSpi = HealPointsCalculator_ExtraSpi * getglobal("HealPointsVariables2InputBox"):GetNumber();
	setStatInfo(2, "Spirit:", currentSpirit, extraSpi, "%5.0f");

	-- Max mana															
	local currentMana = UnitManaMax("player");
	local extraMana = HealPointsCalculator_ExtraMana * (getglobal("HealPointsVariables3InputBox"):GetNumber() + 15 * intDelta);
	setStatInfo(3, "Max mana:", currentMana, 15 * intDelta + extraMana, "%5.0f");
	
	-- Mana regen (casting, normal, %casting)
	local manaRegenNormal, manaRegenCasting, manaRegenNormalNew, manaRegenCastingNew, percentRegen = getCurrentAndNewManaRegen();
	local manaRegenCastingDelta = manaRegenCastingNew - manaRegenCasting - getglobal("HealPointsVariables4InputBox"):GetNumber();
	local manaRegenNormalDelta = manaRegenNormalNew - manaRegenNormal - getglobal("HealPointsVariables5InputBox"):GetNumber();
	
	setStatInfo(4, "Casting regen/5s:", manaRegenCasting, manaRegenCastingDelta, "%5.0f");
	setStatInfo(5, "Normal regen/5s:", manaRegenNormal, manaRegenNormalDelta, "%5.0f");
	setStatInfo(6, "% regen while casting:", 100 * percentRegen, 0, "%5.0f");
	
	-- +Healing
	local currentHealing = HealPointsBS:GetBonus('HEAL');
	setStatInfo(7, "+Healing:", currentHealing, 0);
	
	-- Spell crit														
	local currentSpellCrit = getCurrentAndNewSpellCrit();
	setStatInfo(8, "Healing spell crit(%):", currentSpellCrit, intDelta/59.5, "%1.2f");
end

local function updateSpellStats() 	-- Update derived stats about selected spellranks																	
	local _, manaRegenCasting, _, manaRegenCastingNew = getCurrentAndNewManaRegen();
	local currentMana, newMana = getCurrentAndNewMaxMana();
	local currentHealing, newHealing = getCurrentAndNewHealing();
	local currentSpellCrit, newSpellCrit = getCurrentAndNewSpellCrit();	

	-- HP/s
	getglobal("HealPointsSpell1Label"):SetText("HP/s:");

	local oldHPSecFast, newHPSecFast;
	if (SELECTED_FAST ~= nil) then
		oldHPSecFast=getHPSec(SELECTED_FAST, 'fast',currentHealing, currentSpellCrit);
		newHPSecFast=getHPSec(SELECTED_FAST, 'fast',newHealing, newSpellCrit);
		setSpellInfo(1, "Short", oldHPSecFast, newHPSecFast, "%d");
	end

	local oldHPSecSlow, newHPSecSlow;
	if (SELECTED_SLOW ~= nil) then
		oldHPSecSlow=getHPSec(SELECTED_SLOW, 'slow',currentHealing, currentSpellCrit);
		newHPSecSlow=getHPSec(SELECTED_SLOW, 'slow',newHealing, newSpellCrit);
		setSpellInfo(1, "Long", oldHPSecSlow, newHPSecSlow, "%d");
	end

	local oldHPSecHot, newHPSecHot;
	if (SELECTED_HOT ~= nil) then
		oldHPSecHot = getHPSec(SELECTED_HOT, 'hot', currentHealing, currentSpellCrit);
		newHPSecHot = getHPSec(SELECTED_HOT, 'hot', newHealing, newSpellCrit);
		setSpellInfo(1, "HOT", oldHPSecHot, newHPSecHot, "%d");
	end

	-- HP/mana
	getglobal("HealPointsSpell2Label"):SetText("HP/mana:");

	local oldHPManaFast, newHPManaFast;
	if (SELECTED_FAST ~= nil) then
		oldHPManaFast=getHPMana(SELECTED_FAST, 'fast', currentHealing, currentSpellCrit);
		newHPManaFast=getHPMana(SELECTED_FAST, 'fast', newHealing, newSpellCrit);
		setSpellInfo(2, "Short", oldHPManaFast, newHPManaFast, "%1.1f");
	end

	local oldHPManaSlow, newHPManaSlow;
	if (SELECTED_SLOW ~= nil) then
		oldHPManaSlow=getHPMana(SELECTED_SLOW, 'slow', currentHealing, currentSpellCrit);
		newHPManaSlow=getHPMana(SELECTED_SLOW, 'slow', newHealing, newSpellCrit);
		setSpellInfo(2, "Long", oldHPManaSlow, newHPManaSlow, "%1.1f");
	end

	local oldHPManaHot, newHPManaHot;
	if (SELECTED_HOT ~= nil) then
		oldHPManaHot = getHPMana(SELECTED_HOT, 'hot', currentHealing, currentSpellCrit);
		newHPManaHot = getHPMana(SELECTED_HOT, 'hot', newHealing, newSpellCrit);
		setSpellInfo(2, "HOT", oldHPManaHot, newHPManaHot, "%1.1f");
	end

	-- HP/cast
	getglobal("HealPointsSpell3Label"):SetText("HP/cast:");
	if (SELECTED_FAST ~= nil) then
		local oldHPCastFast, newHPCastFast;
		if (SELECTED_FAST['name'] == "Regrowth") then
			oldHPCastFast = oldHPSecFast * (SELECTED_FAST['time'] + SELECTED_FAST['hottime']);
			newHPCastFast = newHPSecFast * (SELECTED_FAST['time'] + SELECTED_FAST['hottime']);
		else
			oldHPCastFast = oldHPSecFast * SELECTED_FAST['time'];
			newHPCastFast = newHPSecFast * SELECTED_FAST['time'];
		end
		setSpellInfo(3, "Short", oldHPCastFast, newHPCastFast, "%d");
	end

	if (SELECTED_SLOW ~= nil) then
		local oldHPCastSlow = oldHPSecSlow * SELECTED_SLOW['time'];
		local newHPCastSlow = newHPSecSlow * SELECTED_SLOW['time'];
		setSpellInfo(3, "Long", oldHPCastSlow, newHPCastSlow, "%d");
	end
	
	if (SELECTED_HOT ~= nil) then
		local oldHPCastHot = oldHPSecHot * SELECTED_HOT['time'];
		local newHPCastHot = newHPSecHot * SELECTED_HOT['time'];
		setSpellInfo(3, "HOT", oldHPCastHot, newHPCastHot, "%d");
	end
	
	-- Max heal (no regen)
	getglobal("HealPointsSpell4Label"):SetText("Tot HP (-r):");

	if (SELECTED_FAST ~= nil) then
		local oldHPTotalFast = getHPTotal(oldHPManaFast, currentMana);
		local newHPTotalFast = getHPTotal(newHPManaFast, newMana);
		setSpellInfo(4, "Short", oldHPTotalFast, newHPTotalFast, "%d");
	end

	if (SELECTED_SLOW ~= nil) then
		local oldHPTotalSlow = getHPTotal(oldHPManaSlow, currentMana);
		local newHPTotalSlow = getHPTotal(newHPManaSlow, newMana);
		setSpellInfo(4, "Long", oldHPTotalSlow, newHPTotalSlow, "%d");
	end
	
	if (SELECTED_HOT ~= nil) then
		local oldHPTotalHot = getHPTotal(oldHPManaHot, currentMana);
		local newHPTotalHot = getHPTotal(newHPManaHot, newMana);
		setSpellInfo(4, "HOT", oldHPTotalHot, newHPTotalHot, "%d");
	end

	-- Max heal (regen)
	getglobal("HealPointsSpell5Label"):SetText("Tot HP (+r):");

	if (SELECTED_FAST ~= nil) then
		local oldHPTotalRegenFast = getHPTotalRegen(SELECTED_FAST, 'fast', currentHealing, currentSpellCrit, manaRegenCasting, currentMana);
		local newHPTotalRegenFast = getHPTotalRegen(SELECTED_FAST, 'fast', newHealing, newSpellCrit, manaRegenCastingNew, newMana);
		setSpellInfo(5, "Short", oldHPTotalRegenFast, newHPTotalRegenFast, "%d");
	end

	if (SELECTED_SLOW ~= nil) then
		local oldHPTotalRegenSlow = getHPTotalRegen(SELECTED_SLOW, 'slow', currentHealing, currentSpellCrit, manaRegenCasting, currentMana);
		local newHPTotalRegenSlow = getHPTotalRegen(SELECTED_SLOW, 'slow', newHealing, newSpellCrit, manaRegenCastingNew, newMana);
		setSpellInfo(5, "Long", oldHPTotalRegenSlow, newHPTotalRegenSlow, "%d");
	end
	
	if (SELECTED_HOT ~= nil) then
		local oldHPTotalRegenHot = getHPTotalRegen(SELECTED_HOT, 'hot', currentHealing, currentSpellCrit, manaRegenCasting, currentMana);
		local newHPTotalRegenHot = getHPTotalRegen(SELECTED_HOT, 'hot', newHealing, newSpellCrit, manaRegenCastingNew, newMana);
		setSpellInfo(5, "HOT", oldHPTotalRegenHot, newHPTotalRegenHot, "%d");
	end
end

local function updateHealPoints() 	-- Update the healpoints statistic																					
	local manaRegenNormal, manaRegenCasting, manaRegenNormalNew, manaRegenCastingNew = getCurrentAndNewManaRegen();
	local currentMana, newMana = getCurrentAndNewMaxMana();
	local currentHealing, newHealing = getCurrentAndNewHealing();
	local currentSpellCrit, newSpellCrit = getCurrentAndNewSpellCrit();	
--	DEFAULT_CHAT_FRAME:AddMessage("Regen: "..manaRegenNormal..","..manaRegenNormalNew.." - "..manaRegenCasting..","..manaRegenCastingNew,1,1,1);
--	DEFAULT_CHAT_FRAME:AddMessage("MaxMana: "..currentMana..","..newMana,1,1,1);
--	DEFAULT_CHAT_FRAME:AddMessage("Healing: "..currentHealing..","..newHealing,1,1,1);
--	DEFAULT_CHAT_FRAME:AddMessage("Crit: "..currentSpellCrit..","..newSpellCrit,1,1,1);
	
	local healPointsCurrent, healedPowerful, healedEfficient, regenInMin, powerfulCurrent, efficientCurrent = 
		HealPointsCalculator_ComputeHealpoints(currentHealing, currentSpellCrit, currentMana, manaRegenCasting, manaRegenNormal);
	
	local healPointsNew, healedPowerfulNew, healedEfficientNew, regenInMinNew, powerfulNew, efficientNew = 
		HealPointsCalculator_ComputeHealpoints(newHealing, newSpellCrit, newMana, manaRegenCastingNew, manaRegenNormalNew);
	
	HP_LastPowerfulCurrent = powerfulCurrent;
	HP_LastPowerfulNew = powerfulNew;
	HP_LastEfficientCurrent = efficientCurrent;
	HP_LastEfficientNew = efficientNew;
	
	setResultInfo(1, "PowerPoints:", healedPowerful, healedPowerfulNew, "%5.0f");
	setResultInfo(2, "+ EndurancePoints:", healedEfficient, healedEfficientNew, "%5.0f");
	setResultInfo(3, "+ RegenPoints:", regenInMin, regenInMinNew, "%5.0f");
	setResultInfo(4, "= HealPoints:", healPointsCurrent, healPointsNew, "%5.0f");
end

-- Global functions
function HealPointsCalculator_ComputeHealpoints(healing, spellCrit, maxMana, manaRegenCasting, manaRegenNormal)
	local manaRegainOnCrit = 0.20 * getTalentRank("Illumination");
	local manaRegainFactor = 1 - (spellCrit / 100) * manaRegainOnCrit;
	local powerPoints, powerfulSpell = computePowerPoints(healing, spellCrit, maxMana, manaRegenCasting, manaRegenNormal, manaRegainFactor);
	local endurancePoints, efficientSpell = computeEndurancePoints(healing, spellCrit, manaRegenCasting, manaRegenNormal, manaRegainFactor);
	
	-- Mana regen in 1 min
	local regenPoints = manaRegenNormal * 12;
	
	-- Healpoints
	local healPoints = powerPoints + endurancePoints + regenPoints;

	return healPoints, powerPoints, endurancePoints, regenPoints, powerfulSpell, efficientSpell;
end

function HealPointsCalculator_ComputeManaRegen()																										
	local manaRegenNormal, manaRegenCasting = getCurrentAndNewManaRegen();
	return manaRegenNormal, manaRegenCasting;
end

function HealPointsCalculator_ComputeSpellCrit()																										
	local currentSpellCrit = getCurrentAndNewSpellCrit();
	return currentSpellCrit;
end

-- Event functions				
function HealPointsCalculator_OnLoad()
	tinsert(UISpecialFrames, "HealPointsCalculator"); -- Esc closes the window
	UIPanelWindows["HealPointsCalculator"] = nil;
	
	-- Register events
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_LEVEL");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_STATS");
	this:RegisterEvent("LEARNED_SPELL_IN_TAB");
	this:RegisterEvent("CHARACTER_POINTS_CHANGED");

	local _, className = UnitClass("player");
	if (className == "PALADIN") then
		SPELLTABLE_FAST = Paladin_Fast;
		SPELLTABLE_SLOW = Paladin_Slow;
		getglobal("HealPointsCalculatorBoL"):SetChecked(1);
	elseif (className == "PRIEST") then
		SPELLTABLE_FAST = Priest_Fast;
		SPELLTABLE_SLOW = Priest_Slow;
		SPELLTABLE_HOT = Priest_Hot;
		getglobal("HealPointsCalculatorBoL"):Hide();
		getglobal("HealPointsCalculatorBoLText"):Hide();
	elseif (className == "DRUID") then
		SPELLTABLE_FAST = Druid_Fast;
		SPELLTABLE_SLOW = Druid_Slow;
		SPELLTABLE_HOT = Druid_Hot;
		getglobal("HealPointsCalculatorBoL"):Hide();
		getglobal("HealPointsCalculatorBoLText"):Hide();
	elseif (className == "SHAMAN") then
		SPELLTABLE_FAST = Shaman_Fast;
		SPELLTABLE_SLOW = Shaman_Slow;
		getglobal("HealPointsCalculatorBoL"):Hide();
		getglobal("HealPointsCalculatorBoLText"):Hide();
	end
	local _, raceName = UnitRace("player");
	if (raceName == "Human") then
		HealPointsCalculator_ExtraSpi = 0.05;
	end
	
	local oldFunc = HealPointsBS_Update;
	HealPointsBS_Update = function () 
		oldFunc(); 
		if (HealPointsCalculator:IsVisible()) then
			updateStats(); 
			updateSpellStats(); 
			updateHealPoints(); 
		end
	end
end

function HealPointsCalculator_OnEvent(event)
	if (event == "LEARNED_SPELL_IN_TAB" or event == "CHARACTER_POINTS_CHANGED") then
		updateSpellLists();
		updateSpellTable();
	end
	-- Do nothing if Calculator frame is not visable
	if (not HealPointsCalculator:IsVisible()) then
		return;
	end
	-- Do nothing if event target is not player
	if ((	event == "UNIT_AURA" or 
			event == "UNIT_LEVEL" or 
			event == "UNIT_MAXMANA" or 
			event == "UNIT_STATS") 
			and not UnitIsUnit(arg1, "player")) then
		return;
	end	
	updateStats();
	updateSpellStats();
	updateHealPoints();
end

function HealPointsCalculator_OnShow()
	if (SELECTED_SLOW == nil) then
		updateSpellLists();
		updateSpellTable();	
	end
	updateStats();
	updateSpellStats();
	updateHealPoints();
end

function HealPointsCalculator_OnEnter()
	local function spellToString(spell)
		return spell['name'].." ("..spell['rank']..")";
	end

	GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	if (this:GetID() == 1) then	-- PowerPoints
		GameTooltip:SetText("PowerPoints", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed in 30 seconds using your most");
		GameTooltip:AddLine("powerful spell, starting with full mana bar.");
		GameTooltip:AddLine("Regeneration and 5 sec rule are taken into account.");
		GameTooltip:AddLine("\nMost powerful spell:", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine(spellToString(HP_LastPowerfulCurrent).." / "..spellToString(HP_LastPowerfulNew));
	elseif (this:GetID() == 2) then -- EndurancePoints
		GameTooltip:SetText("EndurancePoints", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed in 3 minutes using your most");
		GameTooltip:AddLine("efficient spell, starting with empty mana bar.");
		GameTooltip:AddLine("Regeneration and 5 sec rule are taken into account.");
		GameTooltip:AddLine("\nMost efficient spell:", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine(spellToString(HP_LastEfficientCurrent).." / "..spellToString(HP_LastEfficientNew));
	elseif (this:GetID() == 3) then -- RegenPoints
		GameTooltip:SetText("RegenPoints", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Mana regenerated in 1 minute");
		GameTooltip:AddLine("using normal regen.");
	elseif (this:GetID() == 8) then -- Tot. healed without regen
		GameTooltip:SetText("Total hitpoints healed (no regen)", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed with selected spell");
		GameTooltip:AddLine("using the whole mana bar.");
		GameTooltip:AddLine("Regeneration not taken into account.");
	elseif (this:GetID() == 9) then -- Tot. healed with regen
		GameTooltip:SetText("Total hitpoints healed (regen)", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed with selected spell");
		GameTooltip:AddLine("using the whole mana bar.");
		GameTooltip:AddLine("Casting regeneration is taken into account.");
	elseif (this:GetID() == 13) then -- Casting regen
		GameTooltip:SetText("Casting mana regeneration", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Mana regenerated when last spell");
		GameTooltip:AddLine("was casted less than 5 seconds ago.");
	elseif (this:GetID() == 14) then -- Normal regen
		GameTooltip:SetText("Normal mana regeneration", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Mana regenerated when last spell");
		GameTooltip:AddLine("was casted more than 5 seconds ago.");
	end
	GameTooltip:Show();
end

function HealPointsCalculator_OnLeave()
	GameTooltip:Hide();
end

function HealPointsCalculator_OnMouseDown(arg1)
	if (arg1=="LeftButton") then
		HealPointsCalculator:StartMoving();
	end
end

function HealPointsCalculator_OnMouseUp(arg1)
	if (arg1=="LeftButton") then
		HealPointsCalculator:StopMovingOrSizing();
	end
end

function HealPointsCalculatorDropDown_OnClick()
	if (this.owner) then
		UIDropDownMenu_SetSelectedID(this.owner, this:GetID());
		updateSpellTable();
		updateSpellStats();
	end
end

function HealPointsCalculatorReset_OnClick()
	for i = 1, 8, 1 do
		local frame = getglobal("HealPointsVariables"..i);
		local inputBox = getglobal("HealPointsVariables"..i.."InputBox");
		inputBox:SetText("0");
		inputBox:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end
end

function HealPointsCalculatorBoL_OnClick()
	updateSpellStats();
	updateHealPoints();
end

function HealPointsIncrement_OnClick()
	local inputBox = getglobal(strsub(this:GetName(), 1, -16).."InputBox");
	inputBox:SetNumber(inputBox:GetNumber() + 1);
	inputBox:ClearFocus();
end

function HealPointsDecrement_OnClick()
	local inputBox = getglobal(strsub(this:GetName(), 1, -16).."InputBox");
	inputBox:SetNumber(inputBox:GetNumber() - 1);
	inputBox:ClearFocus();
end

function HealPointsInputBox_OnTextChanged()
	local inputBox = getglobal(this:GetName());
	if (inputBox:GetNumber() > 0) then
		inputBox:SetTextColor(GREEN_FONT_COLOR.r, GREEN_FONT_COLOR.g, GREEN_FONT_COLOR.b);
	elseif (inputBox:GetNumber() < 0) then
		inputBox:SetTextColor(RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b);
	else
		inputBox:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end
	updateStats();
	updateSpellStats();
	updateHealPoints();
end

